Lattice Grid Buy a licence

demo D167

Gauge, funnel and radar

The specialist types and what each is for

type: 'gauge' · 'funnel' · 'radar'

Building…
Loading a live grid…

The configuration

<script>
  import { createGrid } from 'https://cdn.jsdelivr.net/npm/@toclocoinc/lattice-grid@1.28.0/lattice-grid.esm.min.js';
  import createLatticeAction from 'https://cdn.jsdelivr.net/npm/@toclocoinc/lattice-grid@1.28.0/modules/svelte.esm.min.js';
  import { createChart } from 'https://cdn.jsdelivr.net/npm/@toclocoinc/lattice-grid@1.28.0/modules/charts.esm.min.js';

  const lattice = createLatticeAction({ createGrid });

  let gaugeEl, funnelEl, radarEl;

  const config = {
    rowKey: 'id',
    columns: [
      { field: 'circuit', title: 'Circuit', layout: { width: 180 } },
      { field: 'region', title: 'Region', filter: { type: 'set' } },
      { field: 'status', title: 'Status', filter: { type: 'set' } },
      { field: 'bandwidth', title: 'Bandwidth', type: 'number' },
      { field: 'charge', title: 'Monthly charge', type: 'number',
        format: { style: 'currency', currency: 'GBP' }, total: 'sum' },
    ],
    rows,  // an array of circuit records
    // onGrid hands over the live grid the moment it is created. A gauge reads one
    // measure, y; funnel and radar read x and y. All three follow the grid's
    // filters and sort.
    onGrid: (grid) => {
      createChart({ grid, container: gaugeEl,  type: 'gauge',  y: 'charge' });
      createChart({ grid, container: funnelEl, type: 'funnel', x: 'status', y: 'charge' });
      createChart({ grid, container: radarEl,  type: 'radar',  x: 'region', y: 'charge' });
    },
  };
</script>

<svelte:head>
  <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/@toclocoinc/lattice-grid@1.28.0/lattice-grid.min.css">
</svelte:head>

<div style="display: grid; grid-template-columns: repeat(3, 1fr); gap: 14px; height: 240px">
  <div bind:this={gaugeEl}></div>
  <div bind:this={funnelEl}></div>
  <div bind:this={radarEl}></div>
</div>
<div use:lattice={config} style="height: 340px; margin-top: 14px"></div>

Lattice Grid Buy a licence

demo D167

Gauge, funnel and radar

The specialist types and what each is for

type: 'gauge' · 'funnel' · 'radar'

Building…
Loading a live grid…

The configuration

import * as ng from '@angular/core';
import { Component, ViewChild, AfterViewInit } from '@angular/core';
import { bootstrapApplication } from '@angular/platform-browser';
import { createGrid } from '@toclocoinc/lattice-grid';
import '@toclocoinc/lattice-grid/css';
import { createChart } from '@toclocoinc/lattice-grid/modules/charts';
import createLatticeGrid from '@toclocoinc/lattice-grid/modules/angular';

const { LatticeGridComponent } = createLatticeGrid({ ng, createGrid });

const columns = [
  { field: 'circuit', title: 'Circuit', layout: { width: 180 } },
  { field: 'region', title: 'Region', filter: { type: 'set' } },
  { field: 'status', title: 'Status', filter: { type: 'set' } },
  { field: 'bandwidth', title: 'Bandwidth', type: 'number' },
  { field: 'charge', title: 'Monthly charge', type: 'number',
    format: { style: 'currency', currency: 'GBP' }, total: 'sum' },
];

const rows = [/* circuit records */];



@Component({
  selector: 'app-root',
  standalone: true,
  imports: [LatticeGridComponent],
  template:
    '<div style="display:grid;grid-template-columns:repeat(3, 1fr);gap:14px;height:210px">' +
    '<div id="gauge"></div>' +
    '<div id="funnel"></div>' +
    '<div id="radar"></div>' +
    '</div>' +
    '<lattice-grid [config]="grid" style="display:block;height:340px;margin-top:14px"></lattice-grid>',
})
export class AppComponent implements AfterViewInit {
  @ViewChild(LatticeGridComponent) gridRef!: LatticeGridComponent;

  grid = {
    rowKey: 'id',
    columns: columns,
    rows: rows,
  };

  ngAfterViewInit() {
    const grid = this.gridRef.grid;
    createChart({ grid, container: '#gauge',  type: 'gauge',  y: 'charge' });
    createChart({ grid, container: '#funnel', type: 'funnel', x: 'status', y: 'charge' });
    createChart({ grid, container: '#radar',  type: 'radar',  x: 'region', y: 'charge' });
  }
}

bootstrapApplication(AppComponent);

Lattice Grid Buy a licence

demo D167

Gauge, funnel and radar

The specialist types and what each is for

type: 'gauge' · 'funnel' · 'radar'

Building…
Loading a live grid…

The configuration

<link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/@toclocoinc/lattice-grid@1.28.0/lattice-grid.min.css">

<div id="app"></div>

<script type="module">
  import React from 'https://esm.sh/react@18';
  import { createRoot } from 'https://esm.sh/react-dom@18/client';
  import { createGrid } from 'https://cdn.jsdelivr.net/npm/@toclocoinc/lattice-grid@1.28.0/lattice-grid.esm.min.js';
  import createLatticeGrid from 'https://cdn.jsdelivr.net/npm/@toclocoinc/lattice-grid@1.28.0/modules/react.esm.min.js';
  import { createChart } from 'https://cdn.jsdelivr.net/npm/@toclocoinc/lattice-grid@1.28.0/modules/charts.esm.min.js';

  const LatticeGrid = createLatticeGrid({ React, createGrid });

  const columns = [
    { field: 'circuit', title: 'Circuit', layout: { width: 180 } },
    { field: 'region', title: 'Region', filter: { type: 'set' } },
    { field: 'status', title: 'Status', filter: { type: 'set' } },
    { field: 'bandwidth', title: 'Bandwidth', type: 'number' },
    { field: 'charge', title: 'Monthly charge', type: 'number',
      format: { style: 'currency', currency: 'GBP' }, total: 'sum' },
  ];

  const rows = [/* circuit records */];

  function App() {
    const gridRef = React.useRef(null);

    // The specialist family, each reading the live grid through the ref, so a
    // filter or an edit redraws every chart together.
    React.useEffect(() => {
      const grid = gridRef.current.grid;
      createChart({ grid, container: '#gauge',  type: 'gauge',  y: 'charge' });
      createChart({ grid, container: '#funnel', type: 'funnel', x: 'status', y: 'charge' });
      createChart({ grid, container: '#radar',  type: 'radar',  x: 'region', y: 'charge' });
    }, []);

    return (
      <>
        <div style={{ display: 'grid', gridTemplateColumns: 'repeat(3, 1fr)', gap: '14px', height: '210px' }}>
          <div id="gauge" />
          <div id="funnel" />
          <div id="radar" />
        </div>
        <LatticeGrid
          ref={gridRef}
          rowKey="id"
          columns={columns}
          rows={rows}
          style={{ height: '340px', marginTop: '14px' }}
        />
      </>
    );
  }

  createRoot(document.getElementById('app')).render(<App />);
</script>